/* ************************* BEGIN HINWEISE *************************
 * Erstellen einer Entwicklungsumgebung:
 * 		http://robertnyman.com/2009/01/24/how-to-develop-a-firefox-extension/
 * 		https://developer.mozilla.org/de/Einrichten_einer_Entwicklungsumgebung_f%C3%BCr_Erweiterungen
 * 
 * Infos zu AJAX und XMLHttpRequest (beginnt ab 6.)
 *      http://molily.de/js/ajax.html
 *      
 * Zum Thema "BrowserToolbarPalette" entfernen von Buttons ...
 *      http://support.mozilla.com/tiki-view_forum_thread.php?locale=he&comments_parentId=78018&forumId=1
 *      
 * Valid Application Versions
 * 		https://addons.mozilla.org/en-US/firefox/pages/appversions
 *
 * ************************** END HINWEISE ************************** */


// Ohne diesen EventListener wird die Funktion frankentool_init zu früh ausgeführt und der Haken für
// die Auswahl des Toolbar-Menus nicht richtig gesetzt
window.addEventListener("load", frankentool_init, false);



// Erste "Einstellungen", wenn Firefox lädt
function frankentool_init() {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	
	
	
	// Wenn die Variable "extensions.frankentool.menu" zwar auf "true" steht, der Franken-Tool-
	// Toolbar-Menu-Button aber nicht im Toolbar-Menu enthalten ist, dann wurde der Button manuell
	// entfernt und die Einstellung "extensions.frankentool.menu" soll auf "false" gestellt werden!
	var ft_toolbar_menu = prefManager.getBoolPref("extensions.frankentool.menu");
	var firefoxnav      = document.getElementById("nav-bar");
	var curSet = firefoxnav.currentSet;
	// Ergibt z.B.:
	//   * unified-back-forward-button,reload-button,stop-button,home-button,urlbar-container,search-container
	//   * unified-back-forward-button,reload-button,stop-button,home-button,toolbar_frankentool,urlbar-container,search-container
	if (ft_toolbar_menu == true && curSet.indexOf("toolbar_frankentool") == -1) {
		prefManager.setBoolPref("extensions.frankentool.menu", false);
	}
	
	
	
	// Setzen der richtigen Haken in den Auswahlmenüs
	//   -> Ist das Toolbar-Menu aktiviert?
	ft_toolbar_menu = prefManager.getBoolPref("extensions.frankentool.menu");
	d1 = document.getElementById("frankentool_toolbar_menu");
	d1.setAttribute("checked", ft_toolbar_menu);
	d2 = document.getElementById("tb_frankentool_toolbar_menu");
	if (d2 != null) {
		d2.setAttribute("checked", ft_toolbar_menu);
	}
	
	
	
	// "Fake-default"-Auswahl für den Franken-Tool-Toolbar-Menu-Button (das Popup) ... wenn man auf
	// den Button klickt soll die selbe Aktion gestartet werden, wie bei einem Klick auf das oberste
	// Element des Popups, deshalb wird dies "fetter" dargestellt
	d3 = document.getElementById("tb_frankentool_scannen")
	if (d3 != null) {
		d3.setAttribute("style", "font-weight: bolder;");
	}
	
	
	
	// Franken-Tool-Toolbar-Menu-Button am Anfang ausblenden, wenn "extensions.frankentool.menu" auf
	// "false" steht
	if (ft_toolbar_menu == false && document.getElementById("toolbar_frankentool") != null) {
		var button = document.getElementById("toolbar_frankentool");
		button.hidden = true;
    }
}



function frankentool_InstallInToolbar() {
	var firefoxnav = document.getElementById("nav-bar");
	var curSet = firefoxnav.currentSet;
	var set;
	// Toolbar-Menu-Button nach Möglichkeit vor der "urlbar" positionieren, ansonsten ganz ans 
	// Ende stellen
	if (curSet.indexOf("urlbar-container") != -1) {
		set = curSet.replace(/urlbar-container/, "toolbar_frankentool,urlbar-container");
	} else  {
		set = curSet + ",toolbar_frankentool";
	}
	// Die folgende Zeile wird benötigt, um die Einstellung in der Datei "Profiles\{Profilordner}\
	// localstore.rdf" zu ändern
	firefoxnav.setAttribute("currentset", set);
	// Die folgende Zeile wird benötigt, um den Button auch wirklich in das Toolbar-Menu zu
	// zu schreiben - ohne diese Zeile wird der Button nicht entfernt, wenn man ihn manuell aus dem 
	// Toolbar-Menu zieht
	firefoxnav.currentSet = set;
	document.persist("nav-bar", "currentset");
	
	// If you don't do the following call, funny things happen
	try {
		BrowserToolboxCustomizeDone(true);
	}
	catch (e) { }
}



// Die Funktion "frankentool_check_tb_button" wird aufgerufen, wenn das Franken-Tool Popup-Menu des
// Rechtsklick-Menus öffnet, um zu überprüfen, dass der Haken für "In Symbolleiste anzeigen" richtig
// gesetzt ist
function frankentool_check_tb_button() {
	var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var firefoxnav  = document.getElementById("nav-bar");
	var curSet = firefoxnav.currentSet;
	if (curSet.indexOf("toolbar_frankentool") == -1) {
		// Der Button befindet sich nicht in der Liste (auch nicht "ausgeblendet" in der Liste)
		prefManager.setBoolPref("extensions.frankentool.menu", false);
		d1 = document.getElementById("frankentool_toolbar_menu");
		d1.setAttribute("checked", false);
	}
}

	
	
function frankentool_senden(source) {
    
    // Daten müssen URI encoded werden (Ampersand, ... müssen herausgefiltert werden!)
    source = encodeURIComponent( source );
    
    // Daten aus den preferences holen
    var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var booFeedback = prefManager.getBoolPref("extensions.frankentool.feedback");
    
    // Zum testen
    //var strCallbackUrl = "http://localhost/Franken-Tool/scans.php";
    var strCallbackUrl = prefManager.getCharPref("extensions.frankentool.callbackUrl");
    
    	
    strCallbackUrl = strCallbackUrl +"?sendby=ft_addon";
    
    
    // Source synchron abschicken (Skriptausführung wird angehalten), response interessiert uns nicht
    req = new XMLHttpRequest();    
    req.onreadystatechange = function () {
    	// readyState Codes:
		// 0 = uninitialized
		// 1 = loading
		// 2 = loaded
		// 3 = interactive
		// 4 = complete
    	// status Codes
    	// 200 = OK
        if (req.readyState == 4 && req.status != 200) {
//            alert("Franken-Tool:\nFehler: " + req.status);  // Erzeugt zu viele Meldungen, obwohl alles klappt! ... später analysieren!
        }
        
        if (req.readyState != 4 || req.status != 200) {
            return;
        }

        // readyState = 4 und status = 200
        	//var test = req.getAllResponseHeaders();
//        var intCode = req.getResponseHeader("frankentool-ReturnCode");
//        var retStr  = req.getResponseHeader("frankentool-ErrorMessage");
//        if (intCode === "") {
//            // Wenn kein Header gesendet wird
//            intCode = null;
//        } else {
//            intCode = parseInt(intCode, 10); // Umwandeln der Zeichenkette in eine Zahl im Dezimalzahlensystem
//        }
//        if (retStr === null) {
//        	retStr = "";
//        }
//
//        if (intCode || retStr) {
//        	alert("ErrorCode: "+intCode+"\nErrorString: "+retStr);
//        	//alert("ErrorCode: "+intCode+"\nErrorString: "+retStr+"\nResponse: "+req.responseText);
//		} else if (booFeedback && req.responseText.trim() !== "") {
//            alert(req.responseText.trim() );
//        }
    }; // req.onreadystatechange
    
    req.open('POST', strCallbackUrl, true);
    // 1. Parameter: HTTP-Anfragemethode
    // 2. Parameter: URI
    // 3. Parameter: Legt fest, ob die Anfrage synchron (false) oder asynchron (true) übertragen
    //               werden soll.
    req.setRequestHeader('Content-Length', source.length);
    req.setRequestHeader("Keep-Alive", "300");
    req.setRequestHeader("Connection", "keep-alive"); 
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.send("scan=" +source);

    // Ausgabe des eingelesenen Quellcodes
    //debugview(source);
}
	
// Die Funktion "tb_frankentool_source" wird von den Menu-Elementen des Rechtsklick-Menus aufgerufen
// und überprüft, ob der Quellcode "gültig" ist
function getsource() {
	var source = "";
	var node  = gContextMenu.target.wrappedJSObject;
	
	// Seiten herausfiltern, die nicht von "Scherbenwelten" kommen
		// Daten aus den preferences holen
	    var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	    var booFeedback = prefManager.getBoolPref("extensions.frankentool.feedback");
	    
	var doc = gContextMenu.target.ownerDocument;
	
	if (doc.location == "about:blank" || doc.location.host != "www.scherbenwelten.de") {
        if (booFeedback) {
            alert("Franken-Tool:\nAbbruch, weil keine Scherbenwelten-Seite!");
        }
        return source;
    }
	
	//  Finden des richtigen "Einstiegspunktes"
    while (node.nodeName !== "HTML") {
        node = node.parentNode;
        //alert(node.nodeName);
    }
    
	var source = node.innerHTML;
	
	source = frankentool_prepareSource(source);
	return source;
}



// Die Funktion "frankentool_prepareSource" wird fast von jeder Funktion aufgerufen, um die Slashes 
// aus dem Quellcode zu entfernen und den Quellcode so zu ändern, dass das Franken-Tool etwas damit
// anfangen kann
function frankentool_prepareSource(source) {	
	// Quelltext bearbeiten
	// Stripslashes
	function stripSlashes(str) {
		return str.replace(/\\/g, '');
	}
	source=stripSlashes(source);
	//debugview(source);
	
	// Folgendes ist nötig für Scan der Warenübersicht
	var sErgebnis = source.search(/><b>Ort<\/b><\/td><td/);
	if (sErgebnis != -1) {
		//alert("Scannen der Warenübersicht");
		source = source.replace(/<tbody>/g, '');
		source = source.replace(/<\/tbody>/g, '');
		source = source.replace(/bgcolor="#004400"/g, 'BGCOLOR=#004400');
		source = source.replace(/bgcolor="#006644"/g, 'BGCOLOR=#006644');
		source = source.replace(/bgcolor="#004444"/g, 'BGCOLOR=#004444');
		source = source.replace(/bgcolor="#006600"/g, 'BGCOLOR=#006600');
		source = source.replace(/align="right"/g, 'align=right');
		source = source.replace(/size=\"1\"/g, 'size=1');
	}
	
	// Folgendes ist nötig für Scan des Stadtverbrauchs
	sErgebnis = source.search(/href="rules.php\?rul=stadt">Regeln/);
	if (sErgebnis != -1) {
		//alert("Scannen der Warenübersicht");
		source = source.replace(/<tbody>/g, '');
		source = source.replace(/<\/tbody>/g, '');
		source = source.replace(/ align="middle"/g, '');
	}
	return source;
}



// Die Funktion "frankentool" wird vom dem Menu-Punkt "Franken-Tool: Seite scanneb" des
// "Rechtsklick-Menü" aufgerufen
function frankentool() {
	source = getsource();
	if (source != "") {
		frankentool_senden(source);
	}	
}



// Die Funktion "cm_frankentool_laden" wird vom dem Menu-Punkt "Franken-Tool: Seite scannen und
// laden" des "Rechtsklick-Menü" aufgerufen ___ Der Quellcode wird in die Zwischenablage zu kopiert,
// anschließend wird ein neues Fenster geöffnet, der Quellcode aus der Zwischenablage dort eingefügt
// und das Formular abgesendet.
function cm_frankentool_laden() {
	source = getsource();
	if (source != "") {
		frankentool_laden(source);
	}
}



// Die Funktion "frankentool_neu" wird vom dem Menu-Punkt "Daten kopieren" des "Rechtsklick-Menü"
// aufgerufen ___ Die Funktion kopiert den Quellcode in die Zwischenablage und gibt eine Meldung aus
function frankentool_neu() {
	source = getsource();
	if (source != "") {
		frankentool_kopieren(source);

		alert("Der Quelltext wurde in die Zwischenablage kopiert und\n" +
		      "kann nun auf der Seite des Franken-Tools eingefügt werden.");
	}
}



// Die Funktion "frankentool_kopierenoeffnen" wird vom dem Menu-Punkt "Daten kopieren und FT öffnen"
// des "Rechtsklick-Menü" aufgerufen ___ Die Funktion kopiert den Quelltext in die Zwischenablage
// und öffnet ein neues Fenster. (... in das man dann selber den Quellcode einfügen und das Formular
// absenden kann)
function frankentool_kopierenoeffnen() {
	source = getsource();
	frankentool_kopieren(source);
	if (source != "") {
		gBrowser.selectedTab = gBrowser.addTab("http://www.franken-tool.de/firefox_import.php");
		
		alert("Der Quelltext wurde in die Zwischenablage kopiert und\n" +
		      "kann nun auf dieser Seite eingefügt werden.");
	}
}



// Die Funktion "frankentool_einfuegen" wird vom dem Menu-Punkt "Daten einfügen" des "Rechtsklick-
// Menü" aufgerufen ___ Die Funktion fügt den Quellcode aus der Zwischenablage ein
function frankentool_einfuegen() {
	// Überprüfen, ob die Daten in die Seite "www.franken-tool.de" eingefügt werden sollen!
	var doc = gContextMenu.target.ownerDocument;
	
	if (doc.location == "about:blank" || doc.location.host != "www.franken-tool.de") {
        alert("Franken-Tool:\nAbruch: Daten können nur in die Seite www.franken-tool.de eingefügt werden!");
        return;
    }
    
    
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
	//if (!clip) return false;

	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	//if (!trans) return false;
	trans.addDataFlavor("text/unicode");
	
	clip.getData(trans, clip.kGlobalClipboard);

	var str       = new Object();
	var strLength = new Object();

	trans.getTransferData("text/unicode", str, strLength);
	
	if (str) str       = str.value.QueryInterface(Components.interfaces.nsISupportsString);
	if (str) pastetext = str.data.substring(0, strLength.value / 2);
	
	// Hiermit kann man auf das TEXTAREA-Element zugreifen
	// alert(doc.getElementsByName("scan")[0].value);
	
	// Hiermit wird der kopierte TEXT eingefügt
	doc.getElementsByName("scan")[0].value = pastetext;
	
	// Hiermit wird das FORMULAR abgeschickt
	doc.getElementsByName("scan_formular")[0].submit();
}


//Funktion zeigt ein XUL-Fenster mit dem eingelesenen Quellcode an
function debugview(source) {
	window.openDialog("chrome://frankentool/content/ft_debugview.xul","debugview","chrome",source);
}



// Die Funktion "frankentool_kopieren" wird von verschiedenen Funktionen aufgerufen und kopiert den
// Quellcode in die Zwischenablage
function frankentool_kopieren(source) {
	var str = Components.classes["@mozilla.org/supports-string;1"].
	createInstance(Components.interfaces.nsISupportsString);
	//if (!str) return false;

	str.data = source;

	var trans = Components.classes["@mozilla.org/widget/transferable;1"].
	createInstance(Components.interfaces.nsITransferable);
	//if (!trans) return false;

	trans.addDataFlavor("text/unicode");
	trans.setTransferData("text/unicode", str, source.length * 2);

	var clipid = Components.interfaces.nsIClipboard;
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
	//if (!clip) return false;

	clip.setData(trans, null, clipid.kGlobalClipboard);
}



// Funktion wird aufgerufen von function: frankentool_laden
// Fügt den Quellcode aus der Zwischenablage in die Textarea ein und sendet das Fomular ab
function geladen() {
	var newTabBrowser = getBrowser().getBrowserForTab(getBrowser().selectedTab);
	//newTabBrowser.contentDocument.getElementsByName("scan")[0].value = "Test";
	
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
	//if (!clip) return false;

	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	//if (!trans) return false;
	trans.addDataFlavor("text/unicode");
	
	clip.getData(trans, clip.kGlobalClipboard);

	var str       = new Object();
	var strLength = new Object();

	trans.getTransferData("text/unicode", str, strLength);
	
	if (str) str       = str.value.QueryInterface(Components.interfaces.nsISupportsString);
	if (str) pastetext = str.data.substring(0, strLength.value / 2);
	//alert(pastetext);
	
	// Hiermit kann man auf das TEXTAREA-Element zugreifen
	// alert(doc.getElementsByName("scan")[0].value);
	
	
	
	// Hiermit wird der kopierte TEXT eingefügt
	newTabBrowser.contentDocument.getElementsByName("scan")[0].value = pastetext;
	
	// TEXTAREA und SUBMIT-Button ausblenden
	// (Befüllung mit Text und abschicken erfolgt ja automatisch)
	newTabBrowser.contentDocument.getElementsByName("scan")[0].style.visibility = "hidden";
	newTabBrowser.contentDocument.getElementsByName("scan_formular")[0].style.visibility = "hidden";
	newTabBrowser.contentDocument.getElementById("hinweis").innerHTML = 'Bitte warte kurz ... die Daten werden bereits an das Franken-Tool gesendet und das Franken-Tool sollte gleich laden!';
	
	// Hiermit wird das FORMULAR abgeschickt
	newTabBrowser.contentDocument.getElementsByName("scan_formular")[0].submit();
	
	// Eventlistener wieder entfernen, sonst lädt die Seite andauernd
	newTabBrowser.removeEventListener("load", geladen, true);
}



function frankentool_laden(source) {
	frankentool_kopieren(source);
	// Zum Testen
	//gBrowser.selectedTab = gBrowser.addTab("http://localhost/Franken-Tool/firefox_import.php");
	
	gBrowser.selectedTab = gBrowser.addTab("http://www.franken-tool.de/firefox_import.php");
	
	// Browser-Fenster focusieren
	var newTabBrowser = getBrowser().getBrowserForTab(getBrowser().selectedTab);
	
	// EventListener hinzufügen, um zu warten, bis die Seite komplett geladen ist
	newTabBrowser.addEventListener("load", geladen, true);
}



// Die Funktion "tb_frankentool_source" wird von den Menu-Elementen des Franken-Tool-Toolbar-Button
// aufgerufen und überprüft, ob der Quellcode "gültig" ist
function tb_frankentool_source() {
	var source = "";
	// Seiten herausfiltern, die nicht von "Scherbenwelten" kommen
	// Daten aus den preferences holen
    var prefManager = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var booFeedback = prefManager.getBoolPref("extensions.frankentool.feedback");
    
    var doc = gBrowser.selectedBrowser.contentWindow.wrappedJSObject.document.getElementsByTagName("html")[0].ownerDocument;
    if (doc.location == "about:blank" || doc.location.host != "www.scherbenwelten.de") {
	    if (booFeedback) {
	        alert("Franken-Tool:\nAbbruch, weil keine Scherbenwelten-Seite!");
	    }
	    return(source);
	} else {
		//
		//
		// Beginn webdeveloper
		// Funktionen
		// Alle Dokumente der aktuellen Seite herausfinden
		function frankentool_getDocuments(frame)
		{
		    var documents = new Array();

		    // If the frame is set
		    if(frame)
		    {
		        var frames       = frame.frames;
		        var framesLength = frames.length;

		        // If the frame document exists
		        if(frame.document)
		        {
		            documents.push(frame.document);
		        }

		        // Loop through the frames
		        for(var i = 0; i < framesLength; i++)
		        {
		            documents = documents.concat(frankentool_getDocuments(frames[i]));
		        }
		    }

		    return documents;
		}
		
		// Das aktuelle content window herausfinden
		var ft_contentwindow = window.top.getBrowser().selectedBrowser.contentWindow;
		var documentList = frankentool_getDocuments(ft_contentwindow);
		// Ergibt:
		//      [object XPCNativeWrapper [object HTMLDocument]], ... -> frame['head'] (src=webpagel.php)
		//																Entspricht der Gesamtseite bei
		//																6 Dokumenten
		//		[object XPCNativeWrapper [object HTMLDocument]], ... -> frame['head'] (src=head.php)
		//		[object XPCNativeWrapper [object HTMLDocument]], ... -> frame['body']
		//		[object XPCNativeWrapper [object HTMLDocument]], ... -> frame['mus']
		//		[object XPCNativeWrapper [object HTMLDocument]], ... -> frame['timer']
		//		[object XPCNativeWrapper [object HTMLDocument]]  ... -> frame['musi']
		// Achtung:
		// 		Wenn man sich erst angemeldet hat und in der Adresszeile nur
		//		"http://www.scherbenwelten.de" steht (und nicht
		//		"http://www.scherbenwelten.de/game.html") gibt es nicht nur 6 frames sondern 7!
		// Dann:
		//		[object XPCNativeWrapper [object HTMLDocument]], ... -> Entspricht der Gesamtseite bei
		//																7 Dokumenten
		//		[object XPCNativeWrapper [object HTMLDocument]], ... -> frame['head'] (src=webpagel.php)
		//		[object XPCNativeWrapper [object HTMLDocument]], ... -> frame['head'] (src=head.php)
		//      ...
		// Also:
		//		Bei 6 Dokumenten ist Dokument 3 das Gesuchte
		//		Bei 7 Dokumenten ist Dokument 4 das Gesuchte
		var documentLength = documentList.length;
	    
		// Quelltext des Frames in einer neuen Seite anzeigen
		//BrowserViewSourceOfDocument(documentList[3]);
	    
		// Quelltext in einem neuen Browser-Tab öffnen
		//var newTab = getBrowser().addTab("view-source:" + documentList[3].documentURI);
		
		// documentList[3] .................................. [object XPCNativeWrapper [object HTMLDocument]]
		// documentList[3].wrappedJSObject .................. [object HTMLDocument]
		// documentList[3].wrappedJSObject.body ............. [object HTMLBodyElement]
		// documentList[3].wrappedJSObject.body.innerHTML ... HTML-Inhalt
		
		if (documentLength == 7)
		{
			// Einscannen der Seite mit "http://www.scherbenwelten.de"
			source = documentList[3].wrappedJSObject.body.innerHTML;
		} else if (documentLength == 1)
		{
			// Einscannen nur eines Frames
			source = documentList[0].wrappedJSObject.body.innerHTML;
		} else if (documentLength == 6)
		{
			// Einscannen der Seite mit "http://www.scherbenwelten.de/game.html"
			source = documentList[2].wrappedJSObject.body.innerHTML;
		}
		
		return(source);
	}
}



// Die Funktion "tb_frankentool_scannen" wird von dem Menu-Punkt "Seite scannen" des Franken-Tool-
// Toolbar-Button aufgerufen
function tb_frankentool_scannen() {
	source = tb_frankentool_source();
	if (source != "") {
		source = frankentool_prepareSource(source);
		frankentool_senden(source);
	}
}



// Die Funktion "tb_frankentool_scannen_button" wird von dem Menu-Punkt "Seite scannen" des Franken-
// Tool-Toolbar-Button aufgerufen
function tb_frankentool_scannen_button() {
	source = tb_frankentool_source();
	if (source != "") {
		source = frankentool_prepareSource(source);
		frankentool_senden(source);
		alert("Daten werden gesendet!");
	}
}



// Die Funktion "tb_frankentool_scannen_laden" wird von dem Menu-Punkt "Seite scannen und laden" des
// Franken-Tool-Toolbar-Button aufgerufen
function tb_frankentool_scannen_laden() {
	source = tb_frankentool_source();
	if (source != "") {
		source = frankentool_prepareSource(source);
		frankentool_laden(source);
	}
}



// Die Funktion "tb_frankentool_kopieren" wird von dem Menu-Punkt "Daten kopieren" des Franken-Tool-
// Toolbar-Button aufgerufen
function tb_frankentool_kopieren() {
	source = tb_frankentool_source();
	if (source != "") {
		source = frankentool_prepareSource(source);
		frankentool_kopieren(source);
		alert("Der Quelltext wurde in die Zwischenablage kopiert und\n" +
		      "kann nun auf der Seite des Franken-Tools eingefügt werden.");
	}
}



// Die Funktion "tb_frankentool_kopierenoeffnen" wird von dem Menu-Punkt "Daten kopieren und FT
// öffnen" des Franken-Tool-Toolbar-Button aufgerufen
function tb_frankentool_kopierenoeffnen() {
	source = tb_frankentool_source();
	if (source != "") {
		source = frankentool_prepareSource(source);
		frankentool_kopieren(source);
		gBrowser.selectedTab = gBrowser.addTab("http://www.franken-tool.de/firefox_import.php");
		
		alert("Der Quelltext wurde in die Zwischenablage kopiert und\n" +
		      "kann nun auf dieser Seite eingefügt werden.");
	}
}



// Die Funktion "tb_frankentool_einfuegen" wird von dem Menu-Punkt "Daten einfügen" des Franken-
// Tool-Toolbar-Button aufgerufen
function tb_frankentool_einfuegen() {
	// Überprüfen, ob die Daten in die Seite "www.franken-tool.de" eingefügt werden sollen!
	var doc = gBrowser.selectedBrowser.contentWindow.wrappedJSObject.document.getElementsByTagName("html")[0].ownerDocument;
	
	if (doc.location == "about:blank" || doc.location.host != "www.franken-tool.de") {
        alert("Franken-Tool:\nAbruch: Daten können nur in die Seite www.franken-tool.de eingefügt werden!");
        return;
    }
    
	var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
	//if (!clip) return false;

	var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
	//if (!trans) return false;
	trans.addDataFlavor("text/unicode");
	
	clip.getData(trans, clip.kGlobalClipboard);

	var str       = new Object();
	var strLength = new Object();

	trans.getTransferData("text/unicode", str, strLength);
	
	if (str) str       = str.value.QueryInterface(Components.interfaces.nsISupportsString);
	if (str) pastetext = str.data.substring(0, strLength.value / 2);
	
	// Hiermit wird der kopierte TEXT eingefügt
	doc.getElementsByName("scan")[0].value = pastetext;
	
	// Hiermit wird das FORMULAR abgeschickt
	doc.getElementsByName("scan_formular")[0].submit();
}



function frankentool_homepage()
{
	gBrowser.selectedTab = gBrowser.addTab("http://www.franken-tool.de");
}



// Die Funktion "frankentool_einstellungen" öffnet ein Fenster mit den Einstellungen für das Addon
function frankentool_einstellungen() {
	window.openDialog("chrome://frankentool/content/options.xul","Franken-Tool","chrome=yes,centerscreen");
}



// Über die Funktion "ftTogglePref" werden die Einstellungen verändert und die Haken für die
// Checkboxes gesetzt
function ftTogglePref() {
	var prefManager     = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var ft_toolbar_menu = prefManager.getBoolPref("extensions.frankentool.menu");
    var button = document.getElementById("toolbar_frankentool");
    if (ft_toolbar_menu == false) {
    	// Toolbar-Menu-Button soll eingeblendet werden
    	// Frage: Ist der Button nur "hidden" oder befindet er sich noch gar nicht im Toolbar-Menu?
    	var firefoxnav = document.getElementById("nav-bar");
    	var curSet = firefoxnav.currentSet;
    	if (curSet.indexOf("urlbar-container") != -1) {
    		// Toolbar-Menu-Button befindet sich noch nicht im Toolbar-Menu
    		frankentool_InstallInToolbar();
    	}
    	if (button != null) {
    		button.hidden = false;
    	}
    	prefManager.setBoolPref("extensions.frankentool.menu", true);
    } else {
    	// Toolbar-Menu-Button soll ausgeblendet werden
		button.hidden = true;
		prefManager.setBoolPref("extensions.frankentool.menu", false);
    }
    // Setzen der richtigen Haken
    d1 = document.getElementById("frankentool_toolbar_menu");
	d1.setAttribute("checked", !ft_toolbar_menu);
	d2 = document.getElementById("tb_frankentool_toolbar_menu");
	if (d2 != null) {
		d2.setAttribute("checked", !ft_toolbar_menu);
	}
}